> For the complete documentation index, see [llms.txt](https://docs.win32.run/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.win32.run/developers/spaghetti-code/open-a-program-with-a-file.md).

# Open a program with a file

As mentioned in the [System Variables](/developers/spaghetti-code/system-variables.md) section, work\_space.svelte is the one that handles all the requests to launch programs. To open a file with a program:

```javascript
import {hardDrive, queueProgram} from '$lib/store.js'

let fs_item_id = '';
let fs_item = $hardDrive[fs_item_id];//get the fs_item 

queueProgram.set({
    path: './programs/notepad.svelte',
    fs_item: fs_item
}) 
//request work_space.svelte to open the above fs_item with notepad
//by setting queueProgram
```

In the above example, the `path` './programs/notepad.svelte' is not the actual path of notepad.svelte file.

It's just a unique string for `work_space.svelte` to identifies the requested program, in this case, notepad. Please see `launch` function in work\_space.svelte for all registered programs. You can add your own too.

As long as it's being registered in `launch` function of `work_space.svelte`, any unique string can be used as `path` for launching a program


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.win32.run/developers/spaghetti-code/open-a-program-with-a-file.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
